

local o = LinkBot_TradeskillDB_Links;


local l_SetupMatcher; -- (matcher, text, options)

local l_BuildChatlink; -- link = (ID, name)


local l_PREFIXES_LOWERED_SHORT = {};
do
	for nonLocalizedName, localizedName in pairs(o.TradeskillDB_Links2.TRADESKILL_TYPE_PREFIXES) do
		l_PREFIXES_LOWERED_SHORT[localizedName:lower():sub(1, 3)] = localizedName;
	end
end




function l_SetupMatcher(matcher, text, options)
	if (options ~= nil) then
		options = options:lower();
		local section = options:match("ts:([a-z][a-z][a-z])");
		if (section ~= nil) then
			section = l_PREFIXES_LOWERED_SHORT[section:lower()];
			if (section ~= nil) then
				text = o.TradeskillDB_Links2.CreateSpecificTypeMatchString(section, text);
			end
		end
	end
	local nameCheck = matcher:GetChecksArray()[1];
	nameCheck:SetArg(text, 1);
end

o.SetupMatcher = l_SetupMatcher;




function l_BuildChatlink(ID, name)
	return o.TradeskillDB_Links2.BuildChatlink(ID, name);
end

o.BuildChatlink = l_BuildChatlink;




do
	local LinkBot = LinkBot;
	local section = LinkBot.Sections.AddSection("TradeskillDB_Links", o);
	
	LinkBot.Sections.AddPrefix(section, o.PREFIX_LINKTS);
	o.PREFIX_LINKTS = nil;
	
	local ts1 = TableSearch1;
	local nameCheck = ts1.BuildCheck(ts1.MATCHING_FUNCTIONS.ByStringMatch_NotLowered_WithPatterns, nil, true, false, false, false, 1);
	local matcher = ts1.BuildMatcher((o.TradeskillDB_Links2.GetActiveDB()), nil, true, { nameCheck });
	LinkBot.Sections.SetMatcher(section, matcher);
end

