

local o = TableSearch1; if (o.SHOULD_LOAD == nil) then return; end
local c = {};
local c_metatable;


local l_t_cMatcher_GetLocals; -- classMeta = ()

local l_BuildMatcher; -- matcher = (tbl, maxToGet, shouldMatchAll, checksArray)

-- local l_c_Pairs; -- func, tbl, start = (self)
-- local l_c_FindNextMatch; -- key, value = (self, givenKey)
-- local l_c_DoesPairMatchChecks; -- doesMatch = (key, value)

-- local l_c_GetNumGotten; -- numGotten = (self)
-- local l_c_ResetNumGotten; -- (self)
-- local l_c_GetTable; -- tbl = (self)
-- local l_c_SetTable; -- (self, tbl)
-- local l_c_GetShouldMatchAll; -- shouldMatchAll = (self)
-- local l_c_SetShouldMatchAll; -- (self, shouldMatchAll)
-- local l_c_GetMaxToGet; -- maxToGet = (self)
-- local l_c_SetMaxToGet; -- (self, maxToGet)
-- local l_c_GetChecksArray; -- checksArray = (self)
-- local l_c_SetChecksArray; -- (self, checksArray)

local l_EscapeString; -- escapedString = (unescapedString)
local l_MakeCaseInsensitiveString; -- insensitiveString = (sensitiveString)


local unpack = unpack; -- c:FindNextMatch, c:DoesPairMatchChecks
local stringmatch = string.match; -- ByStringMatch_*
local stringlower = string.lower; -- ByStringMatch_Lowered_*, MakeCaseInsensitiveString
local tableinsert = table.insert; -- MakeCaseInsensitiveString, c:AddCheck
local tableremove = table.remove; -- MakeCaseInsensitiveString, c:RemoveCheck


local l_MATCHING_FUNCTIONS = {
	ByStringMatch_NotLowered_WithoutPatterns = (function(key, name, textToMatch)
		return (stringmatch(name, textToMatch, 1, true) ~= nil);
	end);
	ByStringMatch_NotLowered_WithPatterns = (function(key, name, textToMatch)
		return (stringmatch(name, textToMatch) ~= nil);
	end);
	ByStringMatch_Lowered_WithoutPatterns = (function(key, name, textToMatch)
		return (stringmatch(stringlower(name), textToMatch, 1, true) ~= nil);
	end);
	ByStringMatch_Lowered_WithPatterns = (function(key, name, textToMatch)
		return (stringmatch(stringlower(name), textToMatch) ~= nil);
	end);
};
o.MATCHING_FUNCTIONS = l_MATCHING_FUNCTIONS;


do
	if (o.t_cMatcher_GetLocals ~= nil) then
		c_metatable = o.t_cMatcher_GetLocals();
	else
		c_metatable = (o.c_Matcher_metatable or {});
		o.c_Matcher_metatable = nil;
	end
	c_metatable.__index = c;
end




function l_t_cMatcher_GetLocals()
	l_t_cMatcher_GetLocals = nil;
	o.t_cMatcher_GetLocals = nil;
	
	return c_metatable;
end

o.t_cMatcher_GetLocals = l_t_cMatcher_GetLocals;




function l_BuildMatcher(tbl, maxToGet, shouldMatchAll, checksArray)
	local matcher = { numGotten = 0 };
	setmetatable(matcher, c_metatable);
	matcher:SetTable(tbl);
	matcher:SetMaxToGet(maxToGet);
	matcher:SetShouldMatchAll(shouldMatchAll);
	matcher:SetChecksArray(checksArray);
	return matcher;
end

o.BuildMatcher = l_BuildMatcher;




function c:Pairs()
	self:ResetNumGotten();
	return self.FindNextMatch, self, nil;
end



do
	local next = next;
	
	function c:FindNextMatch(givenKey)
		if (self.maxToGet ~= nil and self.numGotten >= self.maxToGet) then
			return nil, nil;
		end
		
		local tbl = self.tbl;
		local shouldMatchAll = self:GetShouldMatchAll();
		local checks = self:GetChecksArray();
		
		local key, value = next(tbl, givenKey);
		local shouldExecute, index, currCheck, noKey, noValue;
		
		while (key ~= nil) do
			--shouldExecute = self:DoesPairMatchChecks(key, value);
			-- BEGIN: Inline from self:DoesPairMatchChecks() to avoid extra function calls.
			shouldExecute = shouldMatchAll;
			index = 1;
			currCheck = checks[index];
			while (currCheck ~= nil and shouldExecute == shouldMatchAll) do
				noKey, noValue = currCheck[4], currCheck[5];
				if (noKey == nil and noValue == nil) then
					if (currCheck[3] == true) then
						shouldExecute = (currCheck[1](value, key, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
					else
						shouldExecute = (currCheck[1](key, value, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
					end
				elseif (noKey == nil) then
					shouldExecute = (currCheck[1](key, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
				elseif (noValue == nil) then
					shouldExecute = (currCheck[1](value, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
				else
					shouldExecute = (currCheck[1](unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
				end
				index = (index + 1);
				currCheck = checks[index];
			end
			-- END: Inline from self:DoesPairMatchChecks() to avoid extra function calls.
			
			if (shouldExecute == true) then
				self.numGotten = (self.numGotten + 1);
				return key, value;
			else
				key, value = next(tbl, key);
			end
		end
		
		return nil, nil;
	end
end



function c:DoesPairMatchChecks(key, value)
	local shouldMatchAll = self:GetShouldMatchAll();
	local shouldExecute = shouldMatchAll;
	local checks = self:GetChecksArray();
	local index = 1;
	local currCheck = checks[index];
	local noKey, noValue;
	while (currCheck ~= nil and shouldExecute == shouldMatchAll) do
		noKey, noValue = currCheck[4], currCheck[5];
		if (noKey == nil and noValue == nil) then
			if (currCheck[3] == true) then
				shouldExecute = (currCheck[1](value, key, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
			else
				shouldExecute = (currCheck[1](key, value, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
			end
		elseif (noKey == nil) then
			shouldExecute = (currCheck[1](key, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
		elseif (noValue == nil) then
			shouldExecute = (currCheck[1](value, unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
		else
			shouldExecute = (currCheck[1](unpack(currCheck, 7, currCheck[6])) == currCheck[2]);
		end
		index = (index + 1);
		currCheck = checks[index];
	end
	return shouldExecute;
end




function c:GetNumGotten()
	return self.numGotten;
end



function c:ResetNumGotten()
	self.numGotten = 0;
end




function c:GetTable()
	return self.tbl;
end



function c:SetTable(tbl)
	self.tbl = tbl;
end




function c:GetShouldMatchAll()
	return ((self.shouldMatchAll and true) or false);
end



function c:SetShouldMatchAll(shouldMatchAll)
	self.shouldMatchAll = ((shouldMatchAll and true) or nil);
end




function c:GetMaxToGet()
	return self.maxToGet;
end



do
	local tonumber = tonumber;
	
	function c:SetMaxToGet(maxToGet)
		self.maxToGet = ((maxToGet ~= nil and tonumber(maxToGet)) or nil);
	end
end




function c:GetChecksArray()
	return self.checks;
end



function c:SetChecksArray(checksArray)
	local old = self.checks;
	self.checks = (checksArray or {});
	return old;
end




do
	local stringgsub = string.gsub;
	
	function l_EscapeString(input)
		return (stringgsub(input, "[%[%]%(%)%.%+%-%*%?%^%$%%]", "%%%1"));
	end
	
	o.EscapeString = l_EscapeString;
end



do
	local stringupper = string.upper;
	local tableconcat = table.concat;
	
	function l_MakeCaseInsensitiveString(input)
		local newString = {};
		local inBrackets = false;
		local ignoreNext = false;
		local upper, lower;
		
		for char in input:gmatch(".") do
			if (ignoreNext == true) then
				ignoreNext = false;
				tableinsert(newString, char);
			elseif (char == "%") then
				ignoreNext = true;
				tableinsert(newString, "%");
			elseif (char == "[") then
				inBrackets = true;
				tableinsert(newString, "[");
			elseif (char == "]") then
				inBrackets = false;
				tableinsert(newString, "]");
			elseif (inBrackets == false) then
				upper, lower = stringupper(char), stringlower(char);
				if (upper ~= char or lower ~= char) then
					tableinsert(newString, "[");
					tableinsert(newString, lower);
					tableinsert(newString, upper);
					tableinsert(newString, "]");
				else
					tableinsert(newString, char);
				end
			else
				tableinsert(newString, char);
			end
		end
		
		local concatenatedNewString = tableconcat(newString);
		return concatenatedNewString;
	end
	
	o.MakeCaseInsensitiveString = l_MakeCaseInsensitiveString;
end

