

local o = TradeskillLinksMonitor1; if (o.SHOULD_LOAD == nil) then return; end


local l_t_Init; -- ()
local l_t_GetLocals; -- linksTable = ()
local l_t_UnregisterForAllEvents; -- ()

local l_OnEvent_ChatLinksMonitor1_LINKS_FOUND; -- (linksTable, source)
local l_OnEvent_CRAFT_SHOW; -- ()
local l_OnEvent_TRADE_SKILL_SHOW; -- ()

local l_DispatchLinks; -- (linksTable, source)

local l_ParseCrafts; -- (linksTable)
local l_ParseTradeskills; -- (linksTable)


local l_linksTable;


do
	if (o.t_GetLocals ~= nil) then
		l_linksTable = o.t_GetLocals();
	else
		l_linksTable = (o.linksTable or {});
		o.linksTable = nil;
	end
end




function l_t_Init()
	l_t_Init = nil;
	o.t_Init = nil;
	
	local em = EventsManager1;
	em.AddCustomEvent("TradeskillLinksMonitor1_LINKS_FOUND", false);
	
	if (o.t_UnregisterForAllEvents ~= nil) then
		o.t_UnregisterForAllEvents();
	else
		em.UnregisterForAllEvents(o);
	end
	o.t_UnregisterForAllEvents = l_t_UnregisterForAllEvents;
	
	local RFE = em.RegisterForEvent;
	RFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, nil, "ChatLinksMonitor1_LINKS_FOUND", false, false);
	RFE(l_OnEvent_CRAFT_SHOW, nil, "CRAFT_SHOW", false, false); -- For Enchanting.
	RFE(l_OnEvent_TRADE_SKILL_SHOW, nil, "TRADE_SKILL_SHOW", false, false);
end

o.t_Init = l_t_Init;



function l_t_GetLocals()
	l_t_GetLocals = nil;
	o.t_GetLocals = nil;
	
	return l_linksTable;
end

o.t_GetLocals = l_t_GetLocals;



function l_t_UnregisterForAllEvents()
	l_t_UnregisterForAllEvents = nil;
	o.t_UnregisterForAllEvents = nil;
	
	local UFE = o.EventsManager1.UnregisterForEvent;
	UFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, "ChatLinksMonitor1_LINKS_FOUND");
	UFE(l_OnEvent_CRAFT_SHOW, "CRAFT_SHOW");
	UFE(l_OnEvent_TRADE_SKILL_SHOW, "TRADE_SKILL_SHOW");
end




do
	local pairs = pairs;
	local stringsub = string.sub;
	
	function l_OnEvent_ChatLinksMonitor1_LINKS_FOUND(linksTable, source)
		local arrayIndex = #l_linksTable;
		for index, link in pairs(linksTable) do
			if (stringsub(link, 13, 20) == "enchant:") then
				arrayIndex = (arrayIndex + 1);
				l_linksTable[arrayIndex] = link;
			end
		end
		l_DispatchLinks(l_linksTable, ("chat-" .. source));
	end
end



function l_OnEvent_CRAFT_SHOW()
	l_ParseCrafts(l_linksTable);
	l_DispatchLinks(l_linksTable, "crafts");
end



function l_OnEvent_TRADE_SKILL_SHOW()
	l_ParseTradeskills(l_linksTable);
	l_DispatchLinks(l_linksTable, "tradeskills");
end




function l_DispatchLinks(linksTable, source)
	if (#linksTable == 0) then return; end
	
	o.EventsManager1.DispatchEvent("TradeskillLinksMonitor1_LINKS_FOUND", linksTable, source);
	
	for index = #linksTable, 1, -1 do
		linksTable[index] = nil;
	end
end




do
	local GetNumCrafts = GetNumCrafts;
	local GetCraftRecipeLink = GetCraftRecipeLink;
	
	function l_ParseCrafts(linksTable)
		local link;
		local arrayIndex = #linksTable;
		
		for index = GetNumCrafts(), 1, -1 do
			link = GetCraftRecipeLink(index);
			if (link ~= nil) then
				arrayIndex = (arrayIndex + 1);
				linksTable[arrayIndex] = link;
			end
		end
	end
end




do
	local GetNumTradeSkills = GetNumTradeSkills;
	local GetTradeSkillRecipeLink = GetTradeSkillRecipeLink;
	
	function l_ParseTradeskills(linksTable)
		local link;
		local arrayIndex = #linksTable;
		
		for index = GetNumTradeSkills(), 1, -1 do
			link = GetTradeSkillRecipeLink(index);
			if (link ~= nil) then
				arrayIndex = (arrayIndex + 1);
				linksTable[arrayIndex] = link;
			end
		end
	end
end

